searchNodes=[{"ref":"Hades.html","title":"Hades","type":"module","doc":"A wrapper for NMAP written in Elixir. Nmap (network mapper), the god of port scanners used for network discovery and the basis for most security enumeration during the initial stages of a penetration test. The tool was written and maintained by Fyodor AKA Gordon Lyon. Nmap displays exposed services on a target machine along with other useful information such as the verion and OS detection. Nmap has made twelve movie appearances, including The Matrix Reloaded, Die Hard 4, Girl With the Dragon Tattoo, and The Bourne Ultimatum. Nmap in a nutshell Host discovery Port discovery / enumeration Service discovery Operating system version detection Hardware (MAC) address detection Service version detection Vulnerability / exploit detection, using Nmap scripts (NSE"},{"ref":"Hades.html#add_argument/2","title":"Hades.add_argument/2","type":"function","doc":"The add_argument function adds the ability to bind the in Hades.Arguments defined aruments to the given command. Returns a %Hades.Command{} with the added %Hades.Argument{}. Example iex&gt; Hades.new_command() ...&gt; |&gt; Hades.add_argument(Hades.Arguments.ScanTechniques.arg_sP()) %Hades.Command{ scan_types: [ %Hades.Argument{ argument: nil, context: :scan_type, desc: &quot;Ping Scan&quot;, name: &quot;-sP&quot;, options: false } ], target: &quot;&quot; }"},{"ref":"Hades.html#add_target/2","title":"Hades.add_target/2","type":"function","doc":"This function adds the ability to add a specific target_ip to the nmap command. Currently there are only standard formatted IPv4 adresses supported. Inputs with trailing subnmasks are not supported, but I&#39;ll work on this in the future. Returns a %Hades.Command{} with the added target_ip. Example iex&gt; Hades.new_command() ...&gt; |&gt; Hades.add_target(&quot;192.168.120.42&quot;) %Hades.Command{scan_types: [], target: &quot;192.168.120.42&quot;}"},{"ref":"Hades.html#new_command/0","title":"Hades.new_command/0","type":"function","doc":"Begin a new blank (no options) NMAP command. Returns %Hades.Command{}. Example iex&gt; Hades.new_command() %Hades.Command{scan_types: [], target: &quot;&quot;}"},{"ref":"Hades.html#scan/1","title":"Hades.scan/1","type":"function","doc":"With the scan function you can start the execute of a existing nmap command to your desired target. Returns the parsed NMAP output in a map/0. Example iex&gt; Hades.new_command() ...&gt; |&gt; Hades.add_argument(Hades.Arguments.ScanTechniques.arg_sP()) ...&gt; |&gt; Hades.add_target(&quot;192.168.120.42&quot;) ...&gt; |&gt; Hades.scan() %{ hosts: [ %{hostname: &quot;Felixs-MACNCHEESEPRO.root.box&quot;, ip: &quot;192.168.120.42&quot;, ports: []} ], time: %{ elapsed: 0.93, endstr: &quot;Sat Jan 18 10:07:32 2020&quot;, startstr: &quot;Sat Jan 18 10:07:31 2020&quot;, unix: 1579338452 } }"},{"ref":"Hades.Arguments.HostDiscovery.html","title":"Hades.Arguments.HostDiscovery","type":"module","doc":"One of the very first steps in any network reconnaissance mission is to reduce a (sometimes huge) set of IP ranges into a list of active or interesting hosts. Scanning every port of every single IP address is slow and usually unnecessary. Of course what makes a host interesting depends greatly on the scan purposes. Network administrators may only be interested in hosts running a certain service, while security auditors may care about every single device with an IP address. An administrator may be comfortable using just an ICMP ping to locate hosts on his internal network, while an external penetration tester may use a diverse set of dozens of probes in an attempt to evade firewall restrictions. Because host discovery needs are so diverse, Nmap offers a wide variety of options for customizing the techniques used. Host discovery is sometimes called ping scan, but it goes well beyond the simple ICMP echo request packets associated with the ubiquitous ping tool. Users can skip the ping step entirely with a list scan (-sL) or by disabling ping (-Pn), or engage the network with arbitrary combinations of multi-port TCP SYN/ACK, UDP, SCTP INIT and ICMP probes. The goal of these probes is to solicit responses which demonstrate that an IP address is actually active (is being used by a host or network device). On many networks, only a small percentage of IP addresses are active at any given time. This is particularly common with private address space such as 10.0.0.0/8. That network has 16 million IPs, but I have seen it used by companies with less than a thousand machines. Host discovery can find those machines in a sparsely allocated sea of IP addresses. If no host discovery options are given, Nmap sends an ICMP echo request, a TCP SYN packet to port 443, a TCP ACK packet to port 80, and an ICMP timestamp request. These defaults are equivalent to the -PE -PS443 -PA80 -PP options. An exception to this is that an ARP scan is used for any targets which are on a local ethernet network. For unprivileged Unix shell users, the default probes are a SYN packet to ports 80 and 443 using the connect system call.. This host discovery is often sufficient when scanning local networks, but a more comprehensive set of discovery probes is recommended for security auditing. The -P options (which select ping types) can be combined. You can increase your odds of penetrating strict firewalls by sending many probe types using different TCP ports/flags and ICMP codes. Also note that ARP discovery (-PR). is done by default against targets on a local ethernet network even if you specify other -P options, because it is almost always faster and more effective. By default, Nmap does host discovery and then performs a port scan against each host it determines is online. This is true even if you specify non-default host discovery types such as UDP probes (-PU). Read about the -sn option to learn how to perform only host discovery, or use -Pn to skip host discovery and port scan all target hosts."},{"ref":"Hades.Arguments.HostDiscovery.html#arg_PA/0","title":"Hades.Arguments.HostDiscovery.arg_PA/0","type":"function","doc":"ACK discovery to given ports"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_PE/0","title":"Hades.Arguments.HostDiscovery.arg_PE/0","type":"function","doc":"ICMP echo request discovery probes"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_PM/0","title":"Hades.Arguments.HostDiscovery.arg_PM/0","type":"function","doc":"Netmask request discovery probes"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_PO/0","title":"Hades.Arguments.HostDiscovery.arg_PO/0","type":"function","doc":"IP Protocol Ping"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_PP/0","title":"Hades.Arguments.HostDiscovery.arg_PP/0","type":"function","doc":"Timestamp request discovery probes"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_PS/0","title":"Hades.Arguments.HostDiscovery.arg_PS/0","type":"function","doc":"TCP SYN discovery to given ports"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_PU/0","title":"Hades.Arguments.HostDiscovery.arg_PU/0","type":"function","doc":"UDP discovery to given ports"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_PY/0","title":"Hades.Arguments.HostDiscovery.arg_PY/0","type":"function","doc":"SCTP discovery to given ports"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_Pn/0","title":"Hades.Arguments.HostDiscovery.arg_Pn/0","type":"function","doc":"Treat all hosts as online -- skip host discovery"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_R/0","title":"Hades.Arguments.HostDiscovery.arg_R/0","type":"function","doc":"Always resolve [default: sometimes]"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_dns_servers/0","title":"Hades.Arguments.HostDiscovery.arg_dns_servers/0","type":"function","doc":"Specify custom DNS servers"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_n/0","title":"Hades.Arguments.HostDiscovery.arg_n/0","type":"function","doc":"Never do DNS resolution [default: sometimes]"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_raceroute/0","title":"Hades.Arguments.HostDiscovery.arg_raceroute/0","type":"function","doc":"Trace hop path to each host"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_sL/0","title":"Hades.Arguments.HostDiscovery.arg_sL/0","type":"function","doc":"List Scan - simply list targets to scan"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_sn/0","title":"Hades.Arguments.HostDiscovery.arg_sn/0","type":"function","doc":"Ping Scan - disable port scan"},{"ref":"Hades.Arguments.HostDiscovery.html#arg_system_dns/0","title":"Hades.Arguments.HostDiscovery.arg_system_dns/0","type":"function","doc":"Use OS&#39;s DNS resolver"},{"ref":"Hades.Arguments.OSDetection.html","title":"Hades.Arguments.OSDetection","type":"module","doc":"One of Nmap&#39;s best-known features is remote OS detection using TCP/IP stack fingerprinting. Nmap sends a series of TCP and UDP packets to the remote host and examines practically every bit in the responses. After performing dozens of tests such as TCP ISN sampling, TCP options support and ordering, IP ID sampling, and the initial window size check, Nmap compares the results to its nmap-os-db. database of more than 2,600 known OS fingerprints and prints out the OS details if there is a match. Each fingerprint includes a freeform textual description of the OS, and a classification which provides the vendor name (e.g. Sun), underlying OS (e.g. Solaris), OS generation (e.g. 10), and device type (general purpose, router, switch, game console, etc). If Nmap is unable to guess the OS of a machine, and conditions are good (e.g. at least one open port and one closed port were found), Nmap will provide a URL you can use to submit the fingerprint if you know (for sure) the OS running on the machine. By doing this you contribute to the pool of operating systems known to Nmap and thus it will be more accurate for everyone. OS detection enables some other tests which make use of information that is gathered during the process anyway. One of these is TCP Sequence Predictability Classification. This measures approximately how hard it is to establish a forged TCP connection against the remote host. It is useful for exploiting source-IP based trust relationships (rlogin, firewall filters, etc) or for hiding the source of an attack. This sort of spoofing is rarely performed any more, but many machines are still vulnerable to it. The actual difficulty number is based on statistical sampling and may fluctuate. It is generally better to use the English classification such as &quot;worthy challenge&quot; or &quot;trivial joke&quot;. This is only reported in normal output in verbose (-v) mode. When verbose mode is enabled along with -O, IP ID sequence generation is also reported. Most machines are in the &quot;incremental&quot; class, which means that they increment the ID field in the IP header for each packet they send. This makes them vulnerable to several advanced information gathering and spoofing attacks. Another bit of extra information enabled by OS detection is a guess at a target&#39;s uptime. This uses the TCP timestamp option (RFC 1323 [10] ) to guess when a machine was last rebooted. The guess can be inaccurate due to the timestamp counter not being initialized to zero or the counter overflowing and wrapping around, so it is printed only in verbose mode. A paper documenting the workings, usage, and customization of OS detection is available at http://nmap.org/book/osdetect.html."},{"ref":"Hades.Arguments.OSDetection.html#arg_O/0","title":"Hades.Arguments.OSDetection.arg_O/0","type":"function","doc":"Enable OS detection"},{"ref":"Hades.Arguments.OSDetection.html#arg_osscan_guess/0","title":"Hades.Arguments.OSDetection.arg_osscan_guess/0","type":"function","doc":"Guess OS more aggressively"},{"ref":"Hades.Arguments.OSDetection.html#arg_osscan_limit/0","title":"Hades.Arguments.OSDetection.arg_osscan_limit/0","type":"function","doc":"Limit OS detection to promising targets"},{"ref":"Hades.Arguments.ScanTechniques.html","title":"Hades.Arguments.ScanTechniques","type":"module","doc":"As a novice performing automotive repair, I can struggle for hours trying to fit my rudimentary tools (hammer, duct tape, wrench, etc.) to the task at hand. When I fail miserably and tow my jalopy to a real mechanic, he invariably fishes around in a huge tool chest until pulling out the perfect gizmo which makes the job seem effortless. The art of port scanning is similar. Experts understand the dozens of scan techniques and choose the appropriate one (or combination) for a given task. Inexperienced users and script kiddies,. on the other hand, try to solve every problem with the default SYN scan. Since Nmap is free, the only barrier to port scanning mastery is knowledge. That certainly beats the automotive world, where it may take great skill to determine that you need a strut spring compressor, then you still have to pay thousands of dollars for it. Most of the scan types are only available to privileged users.. This is because they send and receive raw packets,. which requires root access on Unix systems. Using an administrator account on Windows is recommended, though Nmap sometimes works for unprivileged users on that platform when WinPcap has already been loaded into the OS. Requiring root privileges was a serious limitation when Nmap was released in 1997, as many users only had access to shared shell accounts. Now, the world is different. Computers are cheaper, far more people have always-on direct Internet access, and desktop Unix systems (including Linux and Mac OS X) are prevalent. A Windows version of Nmap is now available, allowing it to run on even more desktops. For all these reasons, users have less need to run Nmap from limited shared shell accounts. This is fortunate, as the privileged options make Nmap far more powerful and flexible. While Nmap attempts to produce accurate results, keep in mind that all of its insights are based on packets returned by the target machines (or firewalls in front of them). Such hosts may be untrustworthy and send responses intended to confuse or mislead Nmap. Much more common are non-RFC-compliant hosts that do not respond as they should to Nmap probes. FIN, NULL, and Xmas scans are particularly susceptible to this problem. Such issues are specific to certain scan types and so are discussed in the individual scan type entries. This section documents the dozen or so port scan techniques supported by Nmap. Only one method may be used at a time, except that UDP scan (-sU) and any one of the SCTP scan types (-sY, -sZ) may be combined with any one of the TCP scan types. As a memory aid, port scan type options are of the form -sC, where C is a prominent character in the scan name, usually the first. The one exception to this is the deprecated FTP bounce scan (-b). By default, Nmap performs a SYN Scan, though it substitutes a connect scan if the user does not have proper privileges to send raw packets (requires root access on Unix) or if IPv6 targets were specified. Of the scans listed in this section, unprivileged users can only execute connect and FTP bounce scans."},{"ref":"Hades.Arguments.ScanTechniques.html#arg_sA/0","title":"Hades.Arguments.ScanTechniques.arg_sA/0","type":"function","doc":"ACK"},{"ref":"Hades.Arguments.ScanTechniques.html#arg_sM/0","title":"Hades.Arguments.ScanTechniques.arg_sM/0","type":"function","doc":"Maimon scans"},{"ref":"Hades.Arguments.ScanTechniques.html#arg_sP/0","title":"Hades.Arguments.ScanTechniques.arg_sP/0","type":"function","doc":"Ping Scan"},{"ref":"Hades.Arguments.ScanTechniques.html#arg_sS/0","title":"Hades.Arguments.ScanTechniques.arg_sS/0","type":"function","doc":"TCP SYN"},{"ref":"Hades.Arguments.ScanTechniques.html#arg_sT/0","title":"Hades.Arguments.ScanTechniques.arg_sT/0","type":"function","doc":"Connect()"},{"ref":"Hades.Arguments.ScanTechniques.html#arg_sU/0","title":"Hades.Arguments.ScanTechniques.arg_sU/0","type":"function","doc":"UDP Scan"},{"ref":"Hades.Arguments.ScanTechniques.html#arg_sW/0","title":"Hades.Arguments.ScanTechniques.arg_sW/0","type":"function","doc":"Window"},{"ref":"Hades.Arguments.ScriptScan.html","title":"Hades.Arguments.ScriptScan","type":"module","doc":""},{"ref":"Hades.Arguments.ScriptScan.html#arg_sC/0","title":"Hades.Arguments.ScriptScan.arg_sC/0","type":"function","doc":"equivalent to --script=default"},{"ref":"Hades.Arguments.ScriptScan.html#arg_script/1","title":"Hades.Arguments.ScriptScan.arg_script/1","type":"function","doc":"&lt;Lua scripts&gt; is a comma separated list of directories, script-files or script-categories"},{"ref":"Hades.Arguments.ScriptScan.html#arg_script_args/1","title":"Hades.Arguments.ScriptScan.arg_script_args/1","type":"function","doc":"[n2=v2,...]&gt;: provide arguments to scripts"},{"ref":"Hades.Arguments.ScriptScan.html#arg_script_args_file/1","title":"Hades.Arguments.ScriptScan.arg_script_args_file/1","type":"function","doc":"provide NSE script args in a file"},{"ref":"Hades.Arguments.ScriptScan.html#arg_script_help/1","title":"Hades.Arguments.ScriptScan.arg_script_help/1","type":"function","doc":"Show help about scripts. &lt;Lua scripts&gt; is a comma-separated list of script-files or script-categories."},{"ref":"Hades.Arguments.ScriptScan.html#arg_script_trace/1","title":"Hades.Arguments.ScriptScan.arg_script_trace/1","type":"function","doc":"Show all data sent and received"},{"ref":"Hades.Arguments.ScriptScan.html#arg_script_updatedb/0","title":"Hades.Arguments.ScriptScan.arg_script_updatedb/0","type":"function","doc":"Update the script database"},{"ref":"Hades.Arguments.ServiceVersionDetection.html","title":"Hades.Arguments.ServiceVersionDetection","type":"module","doc":""},{"ref":"Hades.Arguments.ServiceVersionDetection.html#arg_sV/0","title":"Hades.Arguments.ServiceVersionDetection.arg_sV/0","type":"function","doc":"Probe open ports to determine service/version info"},{"ref":"Hades.Arguments.ServiceVersionDetection.html#arg_version_all/0","title":"Hades.Arguments.ServiceVersionDetection.arg_version_all/0","type":"function","doc":"Try every single probe (intensity 9)"},{"ref":"Hades.Arguments.ServiceVersionDetection.html#arg_version_intensity/1","title":"Hades.Arguments.ServiceVersionDetection.arg_version_intensity/1","type":"function","doc":"Set from 0 (light) to 9 (try all probes)"},{"ref":"Hades.Arguments.ServiceVersionDetection.html#arg_version_light/0","title":"Hades.Arguments.ServiceVersionDetection.arg_version_light/0","type":"function","doc":"Limit to most likely probes (intensity 2)"},{"ref":"Hades.Arguments.ServiceVersionDetection.html#arg_version_trace/0","title":"Hades.Arguments.ServiceVersionDetection.arg_version_trace/0","type":"function","doc":"Show detailed version scan activity (for debugging)"},{"ref":"Hades.Arguments.html","title":"Hades.Arguments","type":"module","doc":"Convenience to import all currently available NMAP options in Hades. Usage Use the following to use all contained Hades.Arguments: use Hades.Arguments"},{"ref":"Hades.Helpers.html","title":"Hades.Helpers","type":"module","doc":"Provides some usefull functions for internal handling NMAP outputs."},{"ref":"Hades.Helpers.html#check_ip_address/1","title":"Hades.Helpers.check_ip_address/1","type":"function","doc":"With this function it is possible to validate given IP Adresses. Returns {:ok, ip_address} if the given ip_address was validated successfully. Example iex&gt; Hades.Helpers.check_ip_address(&quot;192.168.120.1&quot;) {:ok, &quot;192.168.120.1&quot;}"},{"ref":"Hades.Helpers.html#hades_path/0","title":"Hades.Helpers.hades_path/0","type":"function","doc":"Reads hades output_path from the config. If there is nothing specified in the config then the default path will be returned. Returns binary/0. Example iex&gt; Hades.Helpers.hades_path() &quot;/var/folders/c1/f0tm33sd3tgg_ds8kyhykyw80000gn/T/briefly-1581/hades-73279-791202-3hades/8b09d31e1a1142869ce8b15faf27ed45.xml&quot;"},{"ref":"Hades.Helpers.html#hades_timeout/0","title":"Hades.Helpers.hades_timeout/0","type":"function","doc":"Read hades timeout from the config. If unspecified, return the default timeout which is currently 300_000 (corresponds to 5 minutes). This timeout is propagated to the function Task.await(). If the specified timeout period is exceeded, it is assumed that the process running the NMAP command has timed out. The timeout is specified in ms. Returns integer/0. Example iex&gt; Hades.Helpers.hades_timeout() 300000"},{"ref":"Hades.Helpers.html#option_functions/1","title":"Hades.Helpers.option_functions/1","type":"macro","doc":"Macro used to generate the argument functions that are described inside the Hades.Arguments modules."},{"ref":"Hades.Helpers.html#parse_xml/1","title":"Hades.Helpers.parse_xml/1","type":"function","doc":"This functions parses the given file that is located at filepath and returns a map/0 filled with the hosts and time content that was saved from NMAP into the XML file. Returns map/0. Example iex&gt; Hades.Helpers.parse_xml(&quot;test/mocs/test.xml&quot;) %{ hosts: [ %{hostname: &quot;FelixsMACNCHEESEPRO.root.box&quot;, ip: &quot;192.168.120.42&quot;, ports: []} ], time: %{ elapsed: 0.03, endstr: &quot;Fri Feb 7 09:55:09 2020&quot;, startstr: &quot;Fri Feb 7 09:55:09 2020&quot;, unix: 1581065709 } }"},{"ref":"Hades.Helpers.html#prepare/1","title":"Hades.Helpers.prepare/1","type":"function","doc":"Prepares the command to be executed, by converting the %Command{} into proper parameters to be feeded to NMAP. Under normal circumstances Hades.scan/1 should be used, use prepare only when converted args are needed. Returns {nmap_args_string, the_aimed_target}. Example iex&gt; command = Hades.new_command() ...&gt; |&gt; Hades.add_argument(Hades.Arguments.ServiceVersionDetection.arg_sV()) ...&gt; |&gt; Hades.add_argument(Hades.Arguments.ServiceVersionDetection.arg_version_all()) ...&gt; |&gt; Hades.add_argument(Hades.Arguments.ScriptScan.arg_script(&quot;vulners&quot;)) ...&gt; |&gt; Hades.add_target(&quot;192.168.0.1&quot;) iex&gt; Hades.Helpers.prepare(command) {&quot;--script vulners --version-all -sV&quot;, &quot;192.168.0.1&quot;}"},{"ref":"Hades.Helpers.html#validate_contexts!/2","title":"Hades.Helpers.validate_contexts!/2","type":"function","doc":"Checks if the given context is in the required ones. Raises raise(ArgumentError) if the given context is not in the required ones. Examples iex&gt; Hades.Helpers.validate_contexts!(:option, [:scan_type, :option]) nil iex&gt; Hades.Helpers.validate_contexts!(:undefined, [:scan_type, :option]) ** (ArgumentError) argument error"},{"ref":"Hades.NMAP.html","title":"Hades.NMAP","type":"module","doc":"Executes and monitors the desired NMAP command with the help of GenServer. Terminated or aborted are getting cleaned up with :trap_exit."},{"ref":"Hades.NMAP.html#await/2","title":"Hades.NMAP.await/2","type":"function","doc":""},{"ref":"Hades.NMAP.html#child_spec/1","title":"Hades.NMAP.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Hades.NMAP.html#execute/2","title":"Hades.NMAP.execute/2","type":"function","doc":""},{"ref":"Hades.NMAP.html#init/1","title":"Hades.NMAP.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"readme.html","title":"README","type":"extras","doc":"A wrapper for NMAP written in Elixir. Used version: Nmap 7.80 Nmap (network mapper), the god of port scanners used for network discovery and the basis for most security enumeration during the initial stages of a penetration test. The tool was written and maintained by Fyodor AKA Gordon Lyon. Nmap displays exposed services on a target machine along with other useful information such as the verion and OS detection. Nmap has made twelve movie appearances, including The Matrix Reloaded, Die Hard 4, Girl With the Dragon Tattoo, and The Bourne Ultimatum. Documentation: https://hexdocs.pm/hades INFO:Hades is still under development and by far not complete. Feel free to contribute.See General Informations for more about this project"},{"ref":"readme.html#installation","title":"README - Installation","type":"extras","doc":"To use Hades in your Mix projects, first add Hades as a dependency. def deps do [ {:hades, &quot;~&gt; 0.0.1&quot;}, ] end"},{"ref":"readme.html#prerequisites","title":"README - Prerequisites","type":"extras","doc":"NMAP must be installed. Add nmap command to sudoers Some of the NMAP commands require sudo to be executed. In order to process such commands with Hades you need to add those commads.The following shows an example on how to add one to sudoers: Cmnd_Alias NMAP = /usr/bin/nmap -n -oG - -sU -p * %wheel ALL=(root) NOPASSWD: NMAP Defaults!NMAP !requiretty If you want to know more about NMAP sudo behaviour you can find a thread on SuperUser here:different behavior: “sudo nmap” vs just “nmap”?"},{"ref":"readme.html#configuration","title":"README - Configuration","type":"extras","doc":"You can optionally specify the timeout and the output_path in config.exs: config :hades, timeout: 20_000 config :hades, output_path: &quot;/path/to/your/desired/output/folder&quot; The timeout is specified in milliseconds. If unspecified, return the default timeout which is currently 300_000 (corresponds to 5 minutes). This timeout is propagated to the function Task.await(). If the specified timeout period is exceeded, it is assumed that the process running the NMAP command has timed out. The output_path is the place where the XML output of the executed NMAP command gets stored. If there is nothing specified in the config then the default path (which is located in the tmp folder) will be returned."},{"ref":"readme.html#examples","title":"README - Examples","type":"extras","doc":"Simple ping scan The snippet below ping scans the network, and lists the target machine if it responds to ping. iex&gt; Hades.new_command() ...&gt; |&gt; Hades.add_argument(Hades.Arguments.ScanTechniques.arg_sP()) ...&gt; |&gt; Hades.add_target(&quot;192.168.120.42&quot;) ...&gt; |&gt; Hades.scan() 12:19:25.739 [info] NMAP Output: &quot;Starting Nmap 7.80 ( https://nmap.org ) at 2020-02-07 12:19 CET\\n&quot; 12:19:25.788 [info] NMAP Output: &quot;Nmap scan report for Felix-MACNCHEESEPRO.root.box (192.168.120.42)\\nHost is up (0.00045s latency).\\n&quot; 12:19:25.788 [info] NMAP Output: &quot;Nmap done: 1 IP address (1 host up) scanned in 0.06 seconds\\n&quot; 12:19:25.789 [info] Port exit: :exit_status: 0 12:19:25.789 [info] EXIT 12:19:25.790 [info] DOWN message from port: #Port&lt;0.14&gt; %{ hosts: [ %{hostname: &quot;Felix-MACNCHEESEPRO.root.box&quot;, ip: &quot;192.168.120.42&quot;, ports: []} ], time: %{ elapsed: 0.06, endstr: &quot;Fri Feb 7 12:19:25 2020&quot;, startstr: &quot;Fri Feb 7 12:19:25 2020&quot;, unix: 1581074365 } } INFO: Currently only standard single IPv4 specified targets are supported. In the future I&#39;ll add support for IPv4 ranges specified with a subnetmask. This will enable the functionality to scan targets in a specified IP range. Using the script argument The execution of nmap -sV -version-all -script vulners in Hades looks like the following: iex&gt; Hades.new_command() ...&gt; |&gt; Hades.add_argument(arg_sV()) ...&gt; |&gt; Hades.add_argument(arg_version_all()) ...&gt; |&gt; Hades.add_argument(arg_script(&quot;vulners&quot;)) ...&gt; |&gt; Hades.add_target(&quot;192.168.120.87&quot;) ...&gt; |&gt; Hades.scan() 12:25:13.092 [info] NMAP Output: &quot;Starting Nmap 7.80 ( https://nmap.org ) at 2020-02-07 12:25 CET\\n&quot; 12:25:47.026 [info] NMAP Output: &quot;Nmap scan report for batavis (192.168.120.87)\\n&quot; 12:25:47.030 [info] NMAP Output: &quot;Host is up (0.0076s latency).\\nNot shown: 994 closed ports\\nPORT ... CPE: cpe:/o:linux:linux_kernel\\n\\n&quot; 12:25:47.031 [info] NMAP Output: &quot;Service detection performed. Please report any incorrect results at https://nmap.org/submit/ .\\nNmap done: 1 IP address (1 host up) scanned in 33.97 seconds\\n&quot; 12:25:47.060 [info] Port exit: :exit_status: 0 12:25:47.060 [info] EXIT 12:25:47.060 [info] DOWN message from port: #Port&lt;0.26&gt; %{ hosts: [ %{ hostname: &quot;batavis&quot;, ip: &quot;192.168.120.87&quot;, ports: [ %{ name: &quot;ssh&quot;, output: [], port: 22, product: &quot;OpenSSH&quot;, script: [], state: &quot;open&quot;, version: &quot;7.4p1 Raspbian 10+deb9u6&quot; }, %{ name: &quot;domain&quot;, output: [], port: 53, product: &quot;dnsmasq&quot;, script: [], state: &quot;open&quot;, version: &quot;pi-hole-2.80&quot; }, %{ name: &quot;http&quot;, output: [], port: 80, product: &quot;Node.js Express framework&quot;, script: [], state: &quot;open&quot;, version: &quot;&quot; }, %{ name: &quot;http&quot;, output: [&#39;Problem with XML parsing of /evox/about&#39;], port: 3000, product: &quot;Mongoose httpd&quot;, script: [&quot;http-trane-info&quot;], state: &quot;open&quot;, version: &quot;&quot; }, %{ name: &quot;http&quot;, output: [&#39;lighttpd/1.4.45&#39;, &#39;\\ncpe:/a:lighttpd:lighttpd:1.4.45: \\nCVE-2018-19052\\t5.0\\thttps://vulners.com/cve/CVE-2018-19052&#39;], port: 8042, product: &quot;lighttpd&quot;, script: [&quot;http-server-header&quot;, &quot;vulners&quot;], state: &quot;open&quot;, version: &quot;1.4.45&quot; } ] } ], time: %{ elapsed: 33.97, endstr: &quot;Fri Feb 7 12:25:47 2020&quot;, startstr: &quot;Fri Feb 7 12:25:13 2020&quot;, unix: 1581074747 } } Here the nmap-vulners NSE script is used to provide informations on vulnerabilities of well-known services that are running on the target host."},{"ref":"readme.html#general-informations","title":"README - General Informations","type":"extras","doc":"I started implementing this wrapper because I needed to reliably execute &#39;NMAP&#39; commands in an &#39;Elixir/Phoenix&#39; project. Currently not 100% of the NMAP functionality is implemented, because the current state is sufficient for the current project. But I will complete the functionality as soon as I find the time. In the meantime, if anyone would like to add anything, feel free to do so."},{"ref":"readme.html#release-notes","title":"README - Release notes","type":"extras","doc":"See the changelog for changes between versions."},{"ref":"readme.html#disclaimer","title":"README - Disclaimer","type":"extras","doc":"Hades is not affiliated with nor endorsed by the NMAP project. NMAP was created and is mainted by Gordon Lyon. You can contact him via fyodor@nmap.org. Some of the documentation parts were copyed from the linux man pages nmap(1) - Linux man page"},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog v0.0.1, 07 Feb 2020, Elixir ~&gt; 1.9 Alpha Version release for Hades. NMAP GenServer executor/monitor. Specifyed add_target/1, add_argument/1 and scan/0 functions. [Internal] Some syntax validation must still TBD."}]